package com.galaxis.manatee.entity.chuanyun.data.object;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.galaxis.capsule.bo.ChuanyunObject;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeDeserializer;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeSerializer;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.extern.slf4j.Slf4j;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.*;
import java.time.LocalDateTime;
import java.util.List;

/**
 * @author zcj
 * @version 0.1
 * @date 2020/5/9 10:38 上午
 */
@Slf4j
@EqualsAndHashCode(callSuper = true)
@Data
@Entity(name = "CHUANYUN_LOG")
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChuanyunLogDO extends BasicDO{

    /**
     * 表名
     */
    public static final String SCHEMA_CODE ="D001789cb1cc1bf7bc04964970c65d70be99142";


    /**
     * 用户公司
     */
    @JsonProperty("userCompany")
    private String userCompanyId;
    /**
     * 按天或按周
     */
    private String dayOrWeek;
    /**
     * 用户
     */
    @JsonProperty("user")
    private String userId;
    /**
     * 日志时间
     */
    @JsonSerialize(using = ChuanyunLocalDateTimeSerializer.class)
    @JsonDeserialize(using = ChuanyunLocalDateTimeDeserializer.class)
    @DateTimeFormat(pattern = "yyyy/MM/dd HH:mm:ss")
    @JsonProperty("logDate")
    private LocalDateTime logDate;
    /**
     * 日期
     */
    @JsonSerialize(using = ChuanyunLocalDateTimeSerializer.class)
    @JsonDeserialize(using = ChuanyunLocalDateTimeDeserializer.class)
    @DateTimeFormat(pattern = "yyyy/MM/dd HH:mm:ss")
    @JsonProperty("F0000001")
    private LocalDateTime oldDate;
    /**
     * 日志明细
     */
    @JsonProperty("D001789DayLog")
    @OneToMany(cascade = CascadeType.ALL, orphanRemoval = true,fetch = FetchType.EAGER)
    private List<ChuanyunDayLog> dayLogList;

    /**
     * 周日志明细
     */
    @JsonProperty("D001789WeekLog")
    @Transient
    private List<Object> weekLogList;
    /**
     * 销售日志
     */
    @JsonProperty("D001789F25fd6427f96240aaae768b40ed975b9c")
    @Transient
    private List<ChuanyunDayLogSale> chuanyunDayLogSaleList;
    /**
     * 管理日志
     */
    @JsonProperty("D00178971c566cde3ef422ba5ea6f44a5c07b6a")
    @Transient
    private List<ChuanyunDayLogManagement> chuanyunDayLogManagementList;
    /**
     * 研发日志
     */
    @JsonProperty("D001789be4afb48703740129d653208758179ff")
    @Transient
    private List<ChuanyunDayLogResearch> chuanyunDayLogResearchList;
    /**
     * 工厂日志
     */
    @JsonProperty("D0017891e7c14c23fbc4495a73fc7dc4096203e")
    @Transient
    private List<ChuanyunDayLogFactory> chuanyunDayLogFactoryList;
    /**
     * 实施日志
     */
    @JsonProperty("D001789f6f1ba94c7084686a8a656b115e68377")
    @Transient
    private List<ChuanyunDayLogApply> chuanyunDayLogApplyList;
    /**
     * 二开日志
     */
    @JsonProperty("D00178963d9f808c5c64fef8c0622774fc96f1c")
    @Transient
    private List<ChuanyunDayLogDevelopment> chuanyunDayLogDevelopmentList;
    /**
     * 售后日志
     */
    @JsonProperty("D00178991743b607faa4c13bd47c80f643f48fa")
    @Transient
    private List<ChuanyunDayLogMaintenance> chuanyunDayLogMaintenanceList;
    /**
     * 创建者
     */
    @JsonProperty("CreatedByObject")
    @Transient
    private ChuanyunObject createdByObject;
    /**
     * 用户对象
     */
    @JsonProperty("userObject")
    @Transient
    private ChuanyunObject userObject;
}
