package com.galaxis.manatee.entity.chuanyun.data.object;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeDeserializer;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeSerializer;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.extern.slf4j.Slf4j;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.OneToMany;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.List;

/**
 * @author zcj
 * @version 0.1
 * @date 2020/5/1 11:43 上午
 */
@Slf4j
@EqualsAndHashCode(callSuper = true)
@Data
@Entity(name = "CHUANYUN_SALE_CONTRACT")
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChuanyunSaleContractDO extends BasicDO{

    /**
     * 表名
     */
    public static final String SCHEMA_CODE ="D0017890aeaad9526574422aa5e7403bf5400c3";

    /**
     * 合同名
     */
    @JsonProperty("F0000004")
    private String contractName;
    /**
     * 合同编号
     */
    @JsonProperty("F0000001")
    private String contractCode;
    /**
     * 项目Id
     */
    @JsonProperty("F0000020")
    private String projectId;
    /**
     * 项目编码
     */
    @JsonProperty("F0000025")
    private String projectCode;
    /**
     * 项目类型
     */
    @JsonProperty("F0000051")
    private String projectType;
    /**
     * 签约公司Id
     */
    @JsonProperty("F0000002")
    private String companyId;
    /**
     * 签约时间
     */
    @JsonProperty("F0000003")
    @JsonSerialize(using = ChuanyunLocalDateTimeSerializer.class)
    @JsonDeserialize(using = ChuanyunLocalDateTimeDeserializer.class)
    private LocalDateTime signedDateTime;
    /**
     * 客户Id
     */
    @JsonProperty("F0000027")
    private String clientId;
    /**
     * 合同接收时间
     */
    @JsonProperty("F0000045")
    @JsonSerialize(using = ChuanyunLocalDateTimeSerializer.class)
    @JsonDeserialize(using = ChuanyunLocalDateTimeDeserializer.class)
    private LocalDateTime receivedDateTime;
    /**
     * 项目执行地
     */
    @JsonProperty("F0000028")
    private String location;
    /**
     * 销售负责人Id
     */
    @JsonProperty("F0000043")
    private String salesInChargeId;
    /**
     * 销售负责人名称
     */
    private String salesInChargeName;
    /**
     * 合同接收人Id
     */
    @JsonProperty("F0000044")
    private String contractReceiverId;
    /**
     * 合同接受人姓名
     */
    private String contractReceiverName;
    /**
     * 业主Id
     */
    @JsonProperty("F0000029")
    private String ownerId;
    /**
     * 业主行业
     */
    @JsonProperty("F0000024")
    private String ownerIndustry;
    /**
     * 应用场景
     */
    @JsonProperty("F0000007")
    private String scene;
    /**
     * 备注
     */
    @JsonProperty("F0000046")
    private String content;
    /**
     * 合同类别
     */
    @JsonProperty("F0000005")
    private String contractType;
    /**
     * 合同子类
     */
    @JsonProperty("F0000006")
    private String contractSubType;
    /**
     * 合同总价
     */
    @JsonProperty("F0000021")
    private BigDecimal totalAmount;
    /**
     * 不含税总价
     */
    @JsonProperty("F0000047")
    private BigDecimal totalAmountWithoutTax;
    /**
     * 预估毛利
     */
    @JsonProperty("F0000048")
    private BigDecimal grossProfit;
    /**
     * 预估毛利率
     */
    @JsonProperty("F0000049")
    private BigDecimal grossProfitRate;

    /**
     * 销售合同明细
     */
    @JsonProperty("D001789Ffc834ddecbfe44b084795aa48e80bfcf")
    @OneToMany(cascade = CascadeType.ALL, orphanRemoval = true)
    private List<ChuanyunSaleContractDetailDO> chuanyunSaleContractDetailDOList;
}
