package com.galaxis.manatee.entity.chuanyun.data.object;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.extern.slf4j.Slf4j;

import javax.persistence.Entity;
import java.math.BigDecimal;

/**
 * @author zcj
 * @version 0.1
 * @date 2020/5/1 12:02 下午
 */
@Slf4j
@EqualsAndHashCode(callSuper = true)
@Data
@Entity(name = "CHUANYUN_SALE_CONTRACT_DETAIL")
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChuanyunSaleContractDetailDO extends BasicSubDO{

    /**
     * 表名
     */
    public static final String SCHEMA_CODE ="D001789Ffc834ddecbfe44b084795aa48e80bfcf";
    /**
     * 产品名称
     */
    @JsonProperty("F0000010")
    private String productName;
    /**
     * 规格型号
     */
    @JsonProperty("F0000011")
    private String model;
    /**
     * 设备数量
     */
    @JsonProperty("F0000012")
    private Integer number;
    /**
     * 总价
     */
    @JsonProperty("F0000013")
    private BigDecimal price;
    /**
     * 税率
     */
    @JsonProperty("F0000015")
    private BigDecimal rate;
    /**
     * 未税总价
     */
    @JsonProperty("F0000050")
    private BigDecimal priceWithoutTax;
}
