package com.galaxis.manatee.entity.chuanyun.data.object;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.galaxis.capsule.bo.ChuanyunObject;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.extern.slf4j.Slf4j;

import javax.persistence.Entity;
import javax.persistence.Transient;

/**
 * @author zcj
 * @version 0.1
 * @date 2020/4/28 11:30 上午
 */
@Slf4j
@EqualsAndHashCode(callSuper = true)
@Data
@Entity(name = "CHUANYUN_USER_COMPANY")
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChuanyunUserCompanyDO extends BasicDO{

    /**
     * 表名
     */
    public static final String SCHEMA_CODE ="D001789950a3fb7341840428026c7e41fc035bd";

    /**
     * 用户ID
     */
    @JsonProperty("F0000001")
    private String userName;

    /**
     * 用户Id
     */
    private String userId;

    @Transient
    @JsonProperty("F0000001Object")
    private ChuanyunObject user;

    /**
     * 公司Id
     */
    @JsonProperty("F0000002")
    private String companyId;

    /**
     * 成本中心ID
     */
    @JsonProperty("F0000004")
    private String costId;

    /**
     * 成本中心编号
     */
    @JsonProperty("F0000017")
    private String costCode;

    /**
     * 人员所属部门
     */
    @JsonProperty("F0000007")
    private String department;

    /**
     * 人员所属部门ID
     */
    private String departmentId;
    /**
     * 人工专项处理
     */
    @JsonProperty("F0000020")
    private String specialProcedure;
    /**
     * 是否报工
     */
    @JsonProperty("F0000009")
    private String reportLog;

    /**
     * 人员所属部门对象
     */
    @Transient
    @JsonProperty("F0000007Object")
    private ChuanyunObject departmentObject;
}
