package com.galaxis.manatee.entity.ding;

import lombok.Data;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;

/**
 * @author zcj
 * @version 0.1
 * @date 2020/1/8 10:43 下午
 */
@Data
@Entity
public class DingTalkRobot {
    @Id
    @GeneratedValue(generator = "idGeneratorDingTalkRobot")
    @GenericGenerator(name ="idGeneratorDingTalkRobot" ,strategy="com.galaxis.capsule.util.GalaxisIdGenerator")
    private Long id;

    /**
     * 机器人名称
     */
    @Column(unique = true)
    private String name;

    /**
     * 调用钉钉机器人的url
     */
    private String url;

    /**
     * 加密方式
     */
    @Enumerated(EnumType.STRING)
    private EncryptionMethod encryptionMethod;

    public enum EncryptionMethod {
        /**
         * 关键字加密
         */
        KEY_WORD,
        /**
         * 密钥签名加密
         */
        SECRET,
        /**
         * ip白名单
         */
        IP
    }

    /**
     * 加密内容
     */
    private String encryption;
}
