package com.galaxis.manatee.util;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonToken;
import com.fasterxml.jackson.databind.*;
import com.fasterxml.jackson.databind.util.ObjectBuffer;
import com.galaxis.manatee.constant.StringConstant;

import java.io.IOException;

/**
 * @author zcj
 * @version 0.1
 * @date 2020/4/12 12:16 下午
 */
public class StringArrayToStringDeserializer extends JsonDeserializer<String> {

    @Override
    public String deserialize(JsonParser p, DeserializationContext deserializationContext) throws IOException
    {
        // Ok: must point to START_ARRAY (or equivalent)
        if (!p.isExpectedStartArrayToken()) {
            return "";
        }
        var stringBuilder=new StringBuilder();
        while (true) {
            var value = p.nextTextValue();

            if (value == null) {
                var t = p.getCurrentToken();

                if (t == JsonToken.END_ARRAY) {
                    break;
                }
                if (t == JsonToken.VALUE_NULL) {
                    continue;
                }
            }
            stringBuilder.append(value).append(StringConstant.SEMICOLON);
        }
        return stringBuilder.toString();
    }
}
